import { Task, TaskType } from './migration';
export declare class InvalidConnectionError extends Error {
    constructor(url: string);
}
export declare class UnsupportedDialectError extends Error {
    constructor(dialect: string);
}
export interface TableRow {
    id: number;
    name: string;
    type: TaskType;
    commit: string;
    head: string;
    applied_at: Date;
}
export declare abstract class DbAdapter {
    abstract init(): Promise<void>;
    abstract getLastMigrationTask(): Promise<Task>;
    abstract logMigrationTask(task: Task): Promise<void>;
    abstract checkIfTaskCanExecute(task: Task): Promise<void>;
    abstract close(): Promise<void>;
    protected rowToTask(row: TableRow): Task;
}
export declare function createAdapterFromUrl(url: string): DbAdapter;
